module Pluralizr

  # List of words that are exceptions to the rules in the RULES constant variable hash.

  EXCEPTIONS_LIST = {
    # SXZCHSH_EXCEPTIONS
    'quiz'          =>    'quizzes',
    'stomach'       =>    'stomachs',
    'epoch'         =>    'epochs',

    # FE_F_EXCEPTIONS
    'chef'          =>    'chefs',
    'dwarf'         =>    'dwarfs',
    'gulf'          =>    'gulfs',
    'hoof'          =>    'hooves',
    'safe'          =>    'safes',
    'surf'          =>    'surfs',
    'turf'          =>    'turfs',

    # EX_EXCEPTIONS
    'annex'         =>    'annexes',
    'complex'       =>    'complexes',
    'duplex'        =>    'duplexes',
    'hex'           =>    'hexes',
    'index'         =>    'indexes',
    'sex'           =>    'sexes',

    # O_EXCEPTIONS
    'albino'        =>    'albinos',
    'armadillo'     =>    'armadillos',
    'auto'          =>    'autos',
    'cello'         =>    'cellos',
    'combo'         =>    'combos',
    'ego'           =>    'egos',
    'halo'          =>    'halos',
    'inferno'       =>    'infernos',
    'lasso'         =>    'lassos',
    'memento'       =>    'mementos',
    'memo'          =>    'memos',
    'piano'         =>    'pianos',
    'photo'         =>    'photos',
    'pro'           =>    'pros',
    'silo'          =>    'silos',
    'solo'          =>    'solos',
    'taco'          =>    'tacos',
    'tuxedo'        =>    'tuxedos',
    'typo'          =>    'typos',

    # UM_EXCEPTIONS
    'album'         =>    'albums',
    'stadium'       =>    'stadiums',
    'minimum'       =>    'minimums',
    'maximum'       =>    'maximums',
    'premium'       =>    'premiums',
    'vacuum'        =>    'vacuums',

    # STRICT_LATIN_ORIGINS
    'radius'        =>    'radii',
    'alumnus'       =>    'alumni',
    'cactus'        =>    'cacti',
    'fungus'        =>    'fungi',
    'nucleus'       =>    'nuclei',
    'genus'         =>    'genera',
    'syllabus'      =>    'syllabi',
    'alga'          =>    'algae',
    'vertebra'      =>    'vertebrae',
    'larva'         =>    'larvae',

    # STRICT_GREEK_ORIGINS
    'automaton'     =>    'automata',
    'criterion'     =>    'criteria',
    'phenomenon'    =>    'phenomena',

    # ITALIAN_ORIGINS
    'espresso'      =>    'espressos',
    'pizza'         =>    'pizzas',
    'risotto'       =>    'risottos',
    'paparazzo'       =>    'paparazzi',
    'spaghetto'       =>    'spaghetti'
  }

  # List of words whose plural form doesn't adhere to a rule in the RULES hash, but instead, often mutates the original word.
  # For example, +mouse+ => +mice+. Or, +foot+ => +feet+.

  IRREGULAR_WORDS = {
    'child'         =>    'children',
    'die'           =>    'dice',
    'foot'          =>    'feet',
    'goose'         =>    'geese',
    'louse'         =>    'lice',
    'man'           =>    'men',
    'mouse'         =>    'mice',
    'ox'            =>    'oxen',
    'person'        =>    'people',
    'that'          =>    'those',
    'this'          =>    'these',
    'tooth'         =>    'teeth',
    'woman'         =>    'women'
  }

  # List of words whose plural form is the same as its singular form.
  # For example, +deer+ is used in both singular and plural contexts.

  SINGULAR_AND_PLURAL_FORMS_ARE_THE_SAME = %w(advice aircraft bison corn deer equipment evidence gold information jewelry kin legislation luck luggage moose music offspring sheep silver swine trousers trout wheat)

  # List of words that only have a plural form. There is no singular form of the word.
  # For example, the word +tweezers+ has no singular form. The word tweezer is actually a verb and not a noun.

  PLURAL_ONLY_WORDS = %w(barracks bellows cattle deer dregs eyeglasses gallows headquarters mathematics means measles mumps news oats pants pliers pajamas scissors series shears shorts species tongs tweezers vespers)

end
